package
{
	import fairygui.GComponent;
	import fairygui.GList;
	import fairygui.GObject;
	import fairygui.GRoot;
	import fairygui.RelationType;
	import fairygui.UIPackage;

	public class MainPanel
	{
		private var _view:GComponent;
		private var _list:GList;
		
		public function MainPanel()
		{
			_view = UIPackage.createObject("Extension", "Main").asCom;
			_view.setSize(GRoot.inst.width, GRoot.inst.height);
			_view.addRelation(GRoot.inst, RelationType.Size);
			GRoot.inst.addChild(_view);

			_list = _view.getChild("mailList").asList;
			for (var i:int = 0; i < 10; i++)
			{
				var item:MailItem = MailItem(_list.addItemFromPool());
				item.setFetched(i % 3 == 0);
				item.setRead(i % 2 == 0);
				item.setTime("5 Nov 2015 16:24:33");
				item.title = "Mail title here";
			}
			
			_list.ensureBoundsCorrect();
			var delay:Number = 0;
			for (i = 0; i < 10; i++)
			{
				item = MailItem(_list.getChildAt(i));
				if (_list.isChildInView(item))
				{
					item.playEffect(delay);
					delay += 0.2;
				}
				else
					break;
			}
		}
		
		private function renderListItem(index:int, obj:GObject):void
		{
			var item:MailItem = MailItem(obj);
			item.setFetched(index % 3 == 0);
			item.setRead(index % 2 == 0);
			item.setTime("5 Nov 2015 16:24:33");
			item.title = index + " Mail title here";
		}

		
	}
}