package
{
	import flash.events.MouseEvent;
	import flash.geom.Rectangle;
	
	import fairygui.Controller;
	import fairygui.DragDropManager;
	import fairygui.GButton;
	import fairygui.GComponent;
	import fairygui.GList;
	import fairygui.GObject;
	import fairygui.GProgressBar;
	import fairygui.GRichTextField;
	import fairygui.GRoot;
	import fairygui.PopupMenu;
	import fairygui.RelationType;
	import fairygui.UIPackage;
	import fairygui.Window;
	import fairygui.event.DragEvent;
	import fairygui.event.DropEvent;
	import fairygui.event.TextEvent;
	import fairygui.utils.GTimers;
	
	import starling.core.Starling;
	import starling.events.Event;

	public class MainPanel
	{
		private var _view:GComponent;
		private var _backBtn:GObject;
		private var _demoContainer:GComponent;
		private var _cc:Controller;
		
		private var _demoObjects:Object;

		public function MainPanel()
		{
			_view = UIPackage.createObject("Basic", "Main").asCom;
			_view.setSize(GRoot.inst.width, GRoot.inst.height);
			_view.addRelation(GRoot.inst, RelationType.Size);
			GRoot.inst.addChild(_view);

			_backBtn = _view.getChild("btn_Back");
			_backBtn.visible = false;
			_backBtn.addClickListener(onClickBack);
			
			_demoContainer = _view.getChild("container").asCom;
			_cc = _view.getController("c1");
			
			var cnt:int = _view.numChildren;
			for(var i:int=0;i<cnt;i++)
			{
				var obj:GObject = _view.getChildAt(i);
				if(obj.group!=null && obj.group.name=="btns")
					obj.addClickListener(runDemo);
			}
			
			_demoObjects = {};
		}
		
		private function runDemo(evt:Event):void
		{
			var type:String = GObject(evt.currentTarget).name.substr(4);
			var obj:GComponent = _demoObjects[type];
			if(obj==null)
			{
				obj = UIPackage.createObject("Basic", "Demo_"+type).asCom;
				_demoObjects[type] = obj;
			}
			
			_demoContainer.removeChildren();
			_demoContainer.addChild(obj);
			_cc.selectedIndex = 1;
			_backBtn.visible = true;
			
			switch(type)
			{
				case "Button":
					playButton();
					break;
				
				case "Text":
					playText();
					break;
				
				case "Grid":
					playGrid();
					break;
				
				case "Transition":
					playTransition();
					break;
				
				case "Window":
					playWindow();
					break;
				
				case "PopupMenu":
					playPopupMenu();
					break;
				
				case "Drag&Drop":
					playDragDrop();
					break;
				
				case "ProgressBar":
					playProgressBar();
					break;
			}				
		}
		
		private function onClickBack(evt:Event):void
		{
			_cc.selectedIndex = 0;
			_backBtn.visible = false;
		}
		
		//------------------------------
		private function playButton():void
		{
			var obj:GComponent = _demoObjects["Button"];
			obj.getChild("n34").addClickListener(__clickButton);
		}
		
		private function __clickButton(evt:Event):void
		{
			trace("click button");
		}
		
		//------------------------------
		private function playText():void
		{
			var obj:GComponent = _demoObjects["Text"];
			//!!注意这里是fairygui.event.TextEvent而不是flash.events.TextEvent
			obj.getChild("n12").asRichTextField.addEventListener(TextEvent.LINK, __clickLink);
			obj.getChild("n22").addClickListener(__clickGetInput);
		}
		
		private function __clickLink(evt:TextEvent):void
		{
			var obj:GRichTextField = evt.currentTarget as GRichTextField;
			obj.text = "[img]ui://9leh0eyft9fj5f[/img][color=#FF0000]你点击了链接[/color]：" + evt.text;
		}
		
		private function __clickGetInput(evt:Event):void
		{
			var obj:GComponent = _demoObjects["Text"];
			obj.getChild("n21").text = obj.getChild("n19").text;
		}
		//------------------------------
		private function playGrid():void
		{
			var obj:GComponent = _demoObjects["Grid"];
			var list1:GList = obj.getChild("list1").asList;
			list1.removeChildrenToPool();
			var testNames: Array = ["IOS","Android","Windows","MacOS"];
			var testColors: Array = [ 0xFFFF00,0xFF0000,0xFFFFFF,0x0000FF ];

			var cnt:int = testNames.length;
			for (var i:int = 0; i < cnt; i++)
			{
				var item:GButton = list1.addItemFromPool().asButton;
				item.getChild("t0").text = "" + (i+1);
				item.getChild("t1").text = testNames[i];
				item.getChild("t2").asTextField.color = testColors[Math.floor(Math.random()*4)];
				item.getChild("star").asProgress.value = (Math.floor(Math.random() * 3)+1) / 3 * 100;
			}
			
			var list2:GList = obj.getChild("list2").asList;
			list2.removeChildrenToPool();
			for (i = 0; i < cnt; i++)
			{
				item = list2.addItemFromPool().asButton;
				item.getChild("cb").asButton.selected = false;
				item.getChild("t1").text = testNames[i];
				item.getChild("mc").asMovieClip.playing = i % 2 == 0;
				item.getChild("t3").text = "" + Math.floor(Math.random() * 10000)
			}
		}
		
		//------------------------------
		private function playTransition():void
		{
			var obj:GComponent = _demoObjects["Transition"];
			obj.getChild("n2").asCom.getTransition("t0").play(null, null, int.MAX_VALUE);
			obj.getChild("n3").asCom.getTransition("peng").play(null, null, int.MAX_VALUE);
			
			obj.addEventListener(Event.REMOVED_FROM_STAGE, __removeFromStage);
		}
		
		private function __removeFromStage(evt:Event):void
		{
			var obj:GComponent = _demoObjects["Transition"];
			obj.getChild("n2").asCom.getTransition("t0").stop();
			obj.getChild("n3").asCom.getTransition("peng").stop();
		}
		
		//------------------------------
		private var _winA:Window;
		private var _winB:Window;
		private function playWindow():void
		{
			var obj:GComponent = _demoObjects["Window"];
			obj.getChild("n0").addClickListener(__showWinA);			
			obj.getChild("n1").addClickListener(__showWinB);
		}
		
		private function __showWinA(evt:Event):void
		{
			if(_winA==null)
				_winA = new WindowA();
			_winA.show();
		}
		
		private function __showWinB(evt:Event):void
		{
			if(_winB==null)
				_winB = new WindowB();
			_winB.show();
		}
		
		//------------------------------
		private var _pm:PopupMenu;
		private function playPopupMenu():void
		{
			if(_pm==null)
			{
				_pm = new PopupMenu();
				_pm.addItem("Item 1");
				_pm.addItem("Item 2");
				_pm.addItem("Item 3");
				_pm.addItem("Item 4");
			}
			
			var obj:GComponent = _demoObjects["PopupMenu"];
			var btn:GObject = obj.getChild("n0");
			btn.addClickListener(__clickMenuBtn);			
			Starling.current.nativeStage.addEventListener(MouseEvent.RIGHT_CLICK, __rightClick);
		}
		
		private function __clickMenuBtn(evt:Event):void
		{
			_pm.show(GObject(evt.currentTarget), true);
		}
		
		private function __rightClick(evt:MouseEvent):void
		{
			_pm.show();
		}
		
		//------------------------------
		private function playDragDrop():void
		{
			var obj:GComponent = _demoObjects["Drag&Drop"];
			obj.getChild("n0").draggable = true;
			
			var btn1:GButton = obj.getChild("n1").asButton;
			btn1.draggable = true;
			btn1.addEventListener(DragEvent.DRAG_START, __dragStart);
			
			var btn2:GButton = obj.getChild("n2").asButton;
			btn2.icon = null;
			btn2.addEventListener(DropEvent.DROP, __drop);
			
			var btn3:GButton = obj.getChild("n7").asButton;
			btn3.draggable = true;
			var bounds:GObject = obj.getChild("bounds");
			var rect:Rectangle = new Rectangle();
			bounds.localToGlobalRect(0, 0, bounds.width, bounds.height, rect);
			GRoot.inst.globalToLocalRect(rect.x, rect.y, rect.width, rect.height, rect);
			
			//---!!Because at this time the container is on the right side of the stage and beginning to move to left(transition),
			//so we need to caculate the final position
			rect.x -= obj.parent.x; 
			//----

			btn3.dragBounds = rect;
		}
		
		private function __dragStart(evt:DragEvent):void
		{
			//取消对原目标的拖动，换成一个替代品
			evt.preventDefault();
			
			var btn:GButton = GButton(evt.currentTarget);
			DragDropManager.inst.startDrag(btn, btn.icon, btn.icon, evt.touchPointID);
		}
		
		private function __drop(evt:DropEvent):void
		{
			GButton(evt.currentTarget).icon = String(evt.source);
		}
		
		//-----------------------------
		private function playProgressBar():void
		{
			var obj:GComponent = _demoObjects["ProgressBar"];
			GTimers.inst.add(50, 0, __playProgress);
			obj.addEventListener(Event.REMOVED_FROM_STAGE, __removeTimer);
		}
		
		private function __removeTimer(evt:Event):void
		{
			GTimers.inst.remove(__playProgress);
		}
		
		private function __playProgress():void
		{
			var obj:GComponent = _demoObjects["ProgressBar"];
			var cnt:int = obj.numChildren;
			for (var i:int = 0; i < cnt; i++)
			{
				var child:GProgressBar = obj.getChildAt(i) as GProgressBar;
				if (child != null)
				{
					child.value += 1;
					if (child.value > child.max)
						child.value = 0;
				}
			}
		}
		
	}
}