package
{
	import fairygui.GComponent;
	import fairygui.GList;
	import fairygui.GObject;
	import fairygui.GRoot;
	import fairygui.RelationType;
	import fairygui.ScrollPane;
	import fairygui.UIPackage;
	import fairygui.utils.GTimers;
	
	import starling.events.Event;

	public class MainPanel
	{
		private var _view:GComponent;
		private var _list1:GList;
		private var _list2:GList;
		
		public function MainPanel()
		{
			_view = UIPackage.createObject("PullToRefresh", "Main").asCom;
			_view.setSize(GRoot.inst.width, GRoot.inst.height);
			_view.addRelation(GRoot.inst, RelationType.Size);
			GRoot.inst.addChild(_view);

			_list1 = _view.getChild("list1").asList;
			_list1.itemRenderer = renderListItem1;
			_list1.setVirtual();
			_list1.numItems = 1;
			_list1.scrollPane.addEventListener(ScrollPane.PULL_DOWN_RELEASE, onPullDownToRefresh);
			
			_list2 = _view.getChild("list2").asList;
			_list2.itemRenderer = renderListItem2;
			_list2.setVirtual();
			_list2.numItems = 1;
			_list2.scrollPane.addEventListener(ScrollPane.PULL_UP_RELEASE, onPullUpToRefresh);
		}
		
		private function renderListItem1(index:int, item:GObject):void
		{
			item.text = "Item " + (_list1.numItems - index - 1);
		}

		private function renderListItem2(index:int, item:GObject):void
		{
			item.text = "Item " + index;
		}
		
		private function onPullDownToRefresh(evt:Event):void
		{
			var header:ScrollPaneHeader = ScrollPaneHeader(_list1.scrollPane.header);
			if (header.readyToRefresh)
			{
				header.setRefreshStatus(2);
				_list1.scrollPane.lockHeader(header.sourceHeight);
				
				//Simulate a async resquest
				GTimers.inst.add(2000, 1, function():void
					{
						_list1.numItems += 5;
						
						//Refresh completed
						header.setRefreshStatus(3);
						_list1.scrollPane.lockHeader(35);
						
						GTimers.inst.add(2000, 1, function():void
							{
								header.setRefreshStatus(0);
								_list1.scrollPane.lockHeader(0);
							});
					});
			}
		}

		private function onPullUpToRefresh(evt:Event):void
		{
			var footer:GComponent = GComponent(_list2.scrollPane.footer);
			
			footer.getController("c1").selectedIndex = 1;
			_list2.scrollPane.lockFooter(footer.sourceHeight);
			
			//Simulate a async resquest
			GTimers.inst.add(2000, 1, function():void
				{
					_list2.numItems += 5;
					
					//Refresh completed
					footer.getController("c1").selectedIndex = 0;
					_list2.scrollPane.lockFooter(0);
				});
		}
	}
}